package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.system.basicData.domain.CrmAdministrativeSupervision;
import com.zksy.system.basicData.service.CrmAdministrativeSupervisionService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 行政监督Controller
 *
 * @author sy
 * @date 2024-04-08
 */
@RestController
@RequestMapping("/crmAdministrativeSupervision")
@Api(tags = "行政监督", description = "行政监督desc")
public class CrmAdministrativeSupervisionController extends BaseController {

    @Autowired
    private CrmAdministrativeSupervisionService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "行政监督搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "行政监督分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "行政监督查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增行政监督
     */
    @PostMapping("/save")
    @ApiOperation(value = "行政监督新增")
    @Log(title = "新增行政监督", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmAdministrativeSupervision crmAdministrativeSupervision) {
        return service.save(crmAdministrativeSupervision);
    }

    /**
     * 修改行政监督
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "行政监督修改")
    @Log(title = "修改行政监督", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmAdministrativeSupervision crmAdministrativeSupervision) {
        return service.updateById(crmAdministrativeSupervision);
    }

    /**
     * 导入行政监督
     */
    @ApiOperation("行政监督导入")
    @Log(title = "行政监督", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmAdministrativeSupervision> crmAdministrativeSupervisionAll = service.list();
            List<CrmAdministrativeSupervision> list = ExcelUtils.readMultipartFile(file, CrmAdministrativeSupervision.class,CrmAdministrativeSupervision.class.getDeclaredFields().length - 2);
            if(crmAdministrativeSupervisionAll != null && crmAdministrativeSupervisionAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("行政监督导出")
    @Log(title = "行政监督", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmAdministrativeSupervision> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"行政监督",wrapperList,CrmAdministrativeSupervision.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "行政监督", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除行政监督", notes = "删除行政监督")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"行政监督检查数据模板");
    }
}

